/**
 */
package tools.descartes.dni.dnimm3ap.impl;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EGenericType;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;
import org.eclipse.emf.ecore.ETypeParameter;
import org.eclipse.emf.ecore.EcorePackage;

import org.eclipse.emf.ecore.impl.EPackageImpl;

import tools.descartes.dni.dnimm3.DNIPackage;

import tools.descartes.dni.dnimm3ap.AdaptableDependency;
import tools.descartes.dni.dnimm3ap.AdaptableEndPerformance;
import tools.descartes.dni.dnimm3ap.AdaptableIntermediatePerformance;
import tools.descartes.dni.dnimm3ap.AdaptableLink;
import tools.descartes.dni.dnimm3ap.AdaptableLinkPerformance;
import tools.descartes.dni.dnimm3ap.AdaptableNetworkInterface;
import tools.descartes.dni.dnimm3ap.AdaptableNetworkInterfacePerformance;
import tools.descartes.dni.dnimm3ap.AdaptableNode;
import tools.descartes.dni.dnimm3ap.AdaptableSdnNodePerformance;
import tools.descartes.dni.dnimm3ap.AdaptableVariable;
import tools.descartes.dni.dnimm3ap.AdaptationGroups;
import tools.descartes.dni.dnimm3ap.AdaptationPoints;
import tools.descartes.dni.dnimm3ap.AdaptationRepository;
import tools.descartes.dni.dnimm3ap.AlternativeDependency;
import tools.descartes.dni.dnimm3ap.AlternativeDependencySet;
import tools.descartes.dni.dnimm3ap.AlternativeVariable;
import tools.descartes.dni.dnimm3ap.AlternativeVariableSet;
import tools.descartes.dni.dnimm3ap.Cost;
import tools.descartes.dni.dnimm3ap.DNIAPFactory;
import tools.descartes.dni.dnimm3ap.DNIAPPackage;
import tools.descartes.dni.dnimm3ap.FixedCostFunction;
import tools.descartes.dni.dnimm3ap.HandlingTime;
import tools.descartes.dni.dnimm3ap.IAdaptableEntity;
import tools.descartes.dni.dnimm3ap.IAdaptableGroupableEntity;
import tools.descartes.dni.dnimm3ap.IAdaptationGroup;
import tools.descartes.dni.dnimm3ap.ICostFunction;
import tools.descartes.dni.dnimm3ap.ICostable;
import tools.descartes.dni.dnimm3ap.Investment;
import tools.descartes.dni.dnimm3ap.LinkAdaptationGroup;
import tools.descartes.dni.dnimm3ap.NodeAdaptationGroup;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Package</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class DNIAPPackageImpl extends EPackageImpl implements DNIAPPackage {
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass adaptationPointsEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass adaptationRepositoryEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass iAdaptableEntityEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass iAdaptableGroupableEntityEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass adaptableNodeEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass adaptableLinkEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass adaptableLinkPerformanceEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass adaptableEndPerformanceEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass adaptableIntermediatePerformanceEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass adaptableSdnNodePerformanceEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass adaptableNetworkInterfaceEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass adaptableNetworkInterfacePerformanceEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass adaptationGroupsEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass iAdaptationGroupEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass nodeAdaptationGroupEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass linkAdaptationGroupEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass alternativeDependencyEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass alternativeDependencySetEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass adaptableDependencyEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass alternativeVariableEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass alternativeVariableSetEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass adaptableVariableEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass iCostableEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass costEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass investmentEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass handlingTimeEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass iCostFunctionEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass fixedCostFunctionEClass = null;

	/**
	 * Creates an instance of the model <b>Package</b>, registered with
	 * {@link org.eclipse.emf.ecore.EPackage.Registry EPackage.Registry} by the package
	 * package URI value.
	 * <p>Note: the correct way to create the package is via the static
	 * factory method {@link #init init()}, which also performs
	 * initialization of the package, or returns the registered package,
	 * if one already exists.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.emf.ecore.EPackage.Registry
	 * @see tools.descartes.dni.dnimm3ap.DNIAPPackage#eNS_URI
	 * @see #init()
	 * @generated
	 */
	private DNIAPPackageImpl() {
		super(eNS_URI, DNIAPFactory.eINSTANCE);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private static boolean isInited = false;

	/**
	 * Creates, registers, and initializes the <b>Package</b> for this model, and for any others upon which it depends.
	 * 
	 * <p>This method is used to initialize {@link DNIAPPackage#eINSTANCE} when that field is accessed.
	 * Clients should not invoke it directly. Instead, they should simply access that field to obtain the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #eNS_URI
	 * @see #createPackageContents()
	 * @see #initializePackageContents()
	 * @generated
	 */
	public static DNIAPPackage init() {
		if (isInited) return (DNIAPPackage)EPackage.Registry.INSTANCE.getEPackage(DNIAPPackage.eNS_URI);

		// Obtain or create and register package
		DNIAPPackageImpl theDNIAPPackage = (DNIAPPackageImpl)(EPackage.Registry.INSTANCE.get(eNS_URI) instanceof DNIAPPackageImpl ? EPackage.Registry.INSTANCE.get(eNS_URI) : new DNIAPPackageImpl());

		isInited = true;

		// Initialize simple dependencies
		DNIPackage.eINSTANCE.eClass();
		EcorePackage.eINSTANCE.eClass();

		// Create package meta-data objects
		theDNIAPPackage.createPackageContents();

		// Initialize created meta-data
		theDNIAPPackage.initializePackageContents();

		// Mark meta-data to indicate it can't be changed
		theDNIAPPackage.freeze();

  
		// Update the registry and return the package
		EPackage.Registry.INSTANCE.put(DNIAPPackage.eNS_URI, theDNIAPPackage);
		return theDNIAPPackage;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getAdaptationPoints() {
		return adaptationPointsEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getAdaptationPoints_Repositories() {
		return (EReference)adaptationPointsEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getAdaptationPoints_Groups() {
		return (EReference)adaptationPointsEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getAdaptationPoints_NetworkInfrastructure() {
		return (EReference)adaptationPointsEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getAdaptationRepository() {
		return adaptationRepositoryEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getAdaptationRepository_Nodes() {
		return (EReference)adaptationRepositoryEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getAdaptationRepository_EndPerformances() {
		return (EReference)adaptationRepositoryEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getAdaptationRepository_IntermediatePerformances() {
		return (EReference)adaptationRepositoryEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getAdaptationRepository_SdnNodePerformances() {
		return (EReference)adaptationRepositoryEClass.getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getAdaptationRepository_NetworkInterfaces() {
		return (EReference)adaptationRepositoryEClass.getEStructuralFeatures().get(4);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getAdaptationRepository_NetworkInterfacePerformances() {
		return (EReference)adaptationRepositoryEClass.getEStructuralFeatures().get(5);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getAdaptationRepository_Links() {
		return (EReference)adaptationRepositoryEClass.getEStructuralFeatures().get(6);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getAdaptationRepository_LinkPerformances() {
		return (EReference)adaptationRepositoryEClass.getEStructuralFeatures().get(7);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getIAdaptableEntity() {
		return iAdaptableEntityEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getIAdaptableEntity_EntityType() {
		return (EReference)iAdaptableEntityEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getIAdaptableGroupableEntity() {
		return iAdaptableGroupableEntityEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getAdaptableNode() {
		return adaptableNodeEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getAdaptableNode_Name() {
		return (EAttribute)adaptableNodeEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getAdaptableNode_EndPerformance() {
		return (EReference)adaptableNodeEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getAdaptableNode_IntermediatePerformance() {
		return (EReference)adaptableNodeEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getAdaptableNode_SdnNodePerformance() {
		return (EReference)adaptableNodeEClass.getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getAdaptableNode_NetworkInterface() {
		return (EReference)adaptableNodeEClass.getEStructuralFeatures().get(4);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getAdaptableNode_AdaptationGroup() {
		return (EReference)adaptableNodeEClass.getEStructuralFeatures().get(5);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getAdaptableLink() {
		return adaptableLinkEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getAdaptableLink_Name() {
		return (EAttribute)adaptableLinkEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getAdaptableLink_LinkPerformance() {
		return (EReference)adaptableLinkEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getAdaptableLink_NetworkInterface() {
		return (EReference)adaptableLinkEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getAdaptableLink_AdaptationGroup() {
		return (EReference)adaptableLinkEClass.getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getAdaptableLinkPerformance() {
		return adaptableLinkPerformanceEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getAdaptableLinkPerformance_Name() {
		return (EAttribute)adaptableLinkPerformanceEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getAdaptableLinkPerformance_PropagationDelay() {
		return (EReference)adaptableLinkPerformanceEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getAdaptableLinkPerformance_MaximalSupportedBandwidth() {
		return (EReference)adaptableLinkPerformanceEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getAdaptableEndPerformance() {
		return adaptableEndPerformanceEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getAdaptableEndPerformance_Name() {
		return (EAttribute)adaptableEndPerformanceEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getAdaptableEndPerformance_SoftwareLayersDelay() {
		return (EReference)adaptableEndPerformanceEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getAdaptableIntermediatePerformance() {
		return adaptableIntermediatePerformanceEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getAdaptableIntermediatePerformance_Name() {
		return (EAttribute)adaptableIntermediatePerformanceEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getAdaptableIntermediatePerformance_ForwardingLatency() {
		return (EReference)adaptableIntermediatePerformanceEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getAdaptableIntermediatePerformance_ForwardingBandwidthBPS() {
		return (EReference)adaptableIntermediatePerformanceEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getAdaptableIntermediatePerformance_SwitchingCapacityPPS() {
		return (EReference)adaptableIntermediatePerformanceEClass.getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getAdaptableSdnNodePerformance() {
		return adaptableSdnNodePerformanceEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getAdaptableSdnNodePerformance_Name() {
		return (EAttribute)adaptableSdnNodePerformanceEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getAdaptableSdnNodePerformance_SoftwareSwitchingPerformance() {
		return (EReference)adaptableSdnNodePerformanceEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getAdaptableSdnNodePerformance_HardwareSwitchingPerformance() {
		return (EReference)adaptableSdnNodePerformanceEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getAdaptableNetworkInterface() {
		return adaptableNetworkInterfaceEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getAdaptableNetworkInterface_Name() {
		return (EAttribute)adaptableNetworkInterfaceEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getAdaptableNetworkInterface_NetworkInterfacePerformance() {
		return (EReference)adaptableNetworkInterfaceEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getAdaptableNetworkInterfacePerformance() {
		return adaptableNetworkInterfacePerformanceEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getAdaptableNetworkInterfacePerformance_Name() {
		return (EAttribute)adaptableNetworkInterfacePerformanceEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getAdaptableNetworkInterfacePerformance_PacketProcessingTime() {
		return (EReference)adaptableNetworkInterfacePerformanceEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getAdaptableNetworkInterfacePerformance_InterfaceThroughput() {
		return (EReference)adaptableNetworkInterfacePerformanceEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getAdaptationGroups() {
		return adaptationGroupsEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getAdaptationGroups_Nodes() {
		return (EReference)adaptationGroupsEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getAdaptationGroups_Links() {
		return (EReference)adaptationGroupsEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getIAdaptationGroup() {
		return iAdaptationGroupEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getNodeAdaptationGroup() {
		return nodeAdaptationGroupEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getNodeAdaptationGroup_Items() {
		return (EReference)nodeAdaptationGroupEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getLinkAdaptationGroup() {
		return linkAdaptationGroupEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getLinkAdaptationGroup_Items() {
		return (EReference)linkAdaptationGroupEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getAlternativeDependency() {
		return alternativeDependencyEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getAlternativeDependencySet() {
		return alternativeDependencySetEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getAlternativeDependencySet_Alternative() {
		return (EReference)alternativeDependencySetEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getAdaptableDependency() {
		return adaptableDependencyEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getAdaptableDependency_Parameter() {
		return (EReference)adaptableDependencyEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getAlternativeVariable() {
		return alternativeVariableEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getAlternativeVariableSet() {
		return alternativeVariableSetEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getAlternativeVariableSet_Alternative() {
		return (EReference)alternativeVariableSetEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getAdaptableVariable() {
		return adaptableVariableEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getAdaptableVariable_Parameter() {
		return (EReference)adaptableVariableEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getICostable() {
		return iCostableEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getICostable_Cost() {
		return (EReference)iCostableEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getCost() {
		return costEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getCost_CostFunction() {
		return (EReference)costEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getInvestment() {
		return investmentEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getHandlingTime() {
		return handlingTimeEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getICostFunction() {
		return iCostFunctionEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getFixedCostFunction() {
		return fixedCostFunctionEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getFixedCostFunction_Value() {
		return (EAttribute)fixedCostFunctionEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public DNIAPFactory getDNIAPFactory() {
		return (DNIAPFactory)getEFactoryInstance();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private boolean isCreated = false;

	/**
	 * Creates the meta-model objects for the package.  This method is
	 * guarded to have no affect on any invocation but its first.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void createPackageContents() {
		if (isCreated) return;
		isCreated = true;

		// Create classes and their features
		adaptationPointsEClass = createEClass(ADAPTATION_POINTS);
		createEReference(adaptationPointsEClass, ADAPTATION_POINTS__REPOSITORIES);
		createEReference(adaptationPointsEClass, ADAPTATION_POINTS__GROUPS);
		createEReference(adaptationPointsEClass, ADAPTATION_POINTS__NETWORK_INFRASTRUCTURE);

		adaptationRepositoryEClass = createEClass(ADAPTATION_REPOSITORY);
		createEReference(adaptationRepositoryEClass, ADAPTATION_REPOSITORY__NODES);
		createEReference(adaptationRepositoryEClass, ADAPTATION_REPOSITORY__END_PERFORMANCES);
		createEReference(adaptationRepositoryEClass, ADAPTATION_REPOSITORY__INTERMEDIATE_PERFORMANCES);
		createEReference(adaptationRepositoryEClass, ADAPTATION_REPOSITORY__SDN_NODE_PERFORMANCES);
		createEReference(adaptationRepositoryEClass, ADAPTATION_REPOSITORY__NETWORK_INTERFACES);
		createEReference(adaptationRepositoryEClass, ADAPTATION_REPOSITORY__NETWORK_INTERFACE_PERFORMANCES);
		createEReference(adaptationRepositoryEClass, ADAPTATION_REPOSITORY__LINKS);
		createEReference(adaptationRepositoryEClass, ADAPTATION_REPOSITORY__LINK_PERFORMANCES);

		iAdaptableEntityEClass = createEClass(IADAPTABLE_ENTITY);
		createEReference(iAdaptableEntityEClass, IADAPTABLE_ENTITY__ENTITY_TYPE);

		iAdaptableGroupableEntityEClass = createEClass(IADAPTABLE_GROUPABLE_ENTITY);

		adaptableNodeEClass = createEClass(ADAPTABLE_NODE);
		createEAttribute(adaptableNodeEClass, ADAPTABLE_NODE__NAME);
		createEReference(adaptableNodeEClass, ADAPTABLE_NODE__END_PERFORMANCE);
		createEReference(adaptableNodeEClass, ADAPTABLE_NODE__INTERMEDIATE_PERFORMANCE);
		createEReference(adaptableNodeEClass, ADAPTABLE_NODE__SDN_NODE_PERFORMANCE);
		createEReference(adaptableNodeEClass, ADAPTABLE_NODE__NETWORK_INTERFACE);
		createEReference(adaptableNodeEClass, ADAPTABLE_NODE__ADAPTATION_GROUP);

		adaptableLinkEClass = createEClass(ADAPTABLE_LINK);
		createEAttribute(adaptableLinkEClass, ADAPTABLE_LINK__NAME);
		createEReference(adaptableLinkEClass, ADAPTABLE_LINK__LINK_PERFORMANCE);
		createEReference(adaptableLinkEClass, ADAPTABLE_LINK__NETWORK_INTERFACE);
		createEReference(adaptableLinkEClass, ADAPTABLE_LINK__ADAPTATION_GROUP);

		adaptableLinkPerformanceEClass = createEClass(ADAPTABLE_LINK_PERFORMANCE);
		createEAttribute(adaptableLinkPerformanceEClass, ADAPTABLE_LINK_PERFORMANCE__NAME);
		createEReference(adaptableLinkPerformanceEClass, ADAPTABLE_LINK_PERFORMANCE__PROPAGATION_DELAY);
		createEReference(adaptableLinkPerformanceEClass, ADAPTABLE_LINK_PERFORMANCE__MAXIMAL_SUPPORTED_BANDWIDTH);

		adaptableEndPerformanceEClass = createEClass(ADAPTABLE_END_PERFORMANCE);
		createEAttribute(adaptableEndPerformanceEClass, ADAPTABLE_END_PERFORMANCE__NAME);
		createEReference(adaptableEndPerformanceEClass, ADAPTABLE_END_PERFORMANCE__SOFTWARE_LAYERS_DELAY);

		adaptableIntermediatePerformanceEClass = createEClass(ADAPTABLE_INTERMEDIATE_PERFORMANCE);
		createEAttribute(adaptableIntermediatePerformanceEClass, ADAPTABLE_INTERMEDIATE_PERFORMANCE__NAME);
		createEReference(adaptableIntermediatePerformanceEClass, ADAPTABLE_INTERMEDIATE_PERFORMANCE__FORWARDING_LATENCY);
		createEReference(adaptableIntermediatePerformanceEClass, ADAPTABLE_INTERMEDIATE_PERFORMANCE__FORWARDING_BANDWIDTH_BPS);
		createEReference(adaptableIntermediatePerformanceEClass, ADAPTABLE_INTERMEDIATE_PERFORMANCE__SWITCHING_CAPACITY_PPS);

		adaptableSdnNodePerformanceEClass = createEClass(ADAPTABLE_SDN_NODE_PERFORMANCE);
		createEAttribute(adaptableSdnNodePerformanceEClass, ADAPTABLE_SDN_NODE_PERFORMANCE__NAME);
		createEReference(adaptableSdnNodePerformanceEClass, ADAPTABLE_SDN_NODE_PERFORMANCE__SOFTWARE_SWITCHING_PERFORMANCE);
		createEReference(adaptableSdnNodePerformanceEClass, ADAPTABLE_SDN_NODE_PERFORMANCE__HARDWARE_SWITCHING_PERFORMANCE);

		adaptableNetworkInterfaceEClass = createEClass(ADAPTABLE_NETWORK_INTERFACE);
		createEAttribute(adaptableNetworkInterfaceEClass, ADAPTABLE_NETWORK_INTERFACE__NAME);
		createEReference(adaptableNetworkInterfaceEClass, ADAPTABLE_NETWORK_INTERFACE__NETWORK_INTERFACE_PERFORMANCE);

		adaptableNetworkInterfacePerformanceEClass = createEClass(ADAPTABLE_NETWORK_INTERFACE_PERFORMANCE);
		createEAttribute(adaptableNetworkInterfacePerformanceEClass, ADAPTABLE_NETWORK_INTERFACE_PERFORMANCE__NAME);
		createEReference(adaptableNetworkInterfacePerformanceEClass, ADAPTABLE_NETWORK_INTERFACE_PERFORMANCE__PACKET_PROCESSING_TIME);
		createEReference(adaptableNetworkInterfacePerformanceEClass, ADAPTABLE_NETWORK_INTERFACE_PERFORMANCE__INTERFACE_THROUGHPUT);

		adaptationGroupsEClass = createEClass(ADAPTATION_GROUPS);
		createEReference(adaptationGroupsEClass, ADAPTATION_GROUPS__NODES);
		createEReference(adaptationGroupsEClass, ADAPTATION_GROUPS__LINKS);

		iAdaptationGroupEClass = createEClass(IADAPTATION_GROUP);

		nodeAdaptationGroupEClass = createEClass(NODE_ADAPTATION_GROUP);
		createEReference(nodeAdaptationGroupEClass, NODE_ADAPTATION_GROUP__ITEMS);

		linkAdaptationGroupEClass = createEClass(LINK_ADAPTATION_GROUP);
		createEReference(linkAdaptationGroupEClass, LINK_ADAPTATION_GROUP__ITEMS);

		alternativeDependencyEClass = createEClass(ALTERNATIVE_DEPENDENCY);

		alternativeDependencySetEClass = createEClass(ALTERNATIVE_DEPENDENCY_SET);
		createEReference(alternativeDependencySetEClass, ALTERNATIVE_DEPENDENCY_SET__ALTERNATIVE);

		adaptableDependencyEClass = createEClass(ADAPTABLE_DEPENDENCY);
		createEReference(adaptableDependencyEClass, ADAPTABLE_DEPENDENCY__PARAMETER);

		alternativeVariableEClass = createEClass(ALTERNATIVE_VARIABLE);

		alternativeVariableSetEClass = createEClass(ALTERNATIVE_VARIABLE_SET);
		createEReference(alternativeVariableSetEClass, ALTERNATIVE_VARIABLE_SET__ALTERNATIVE);

		adaptableVariableEClass = createEClass(ADAPTABLE_VARIABLE);
		createEReference(adaptableVariableEClass, ADAPTABLE_VARIABLE__PARAMETER);

		iCostableEClass = createEClass(ICOSTABLE);
		createEReference(iCostableEClass, ICOSTABLE__COST);

		costEClass = createEClass(COST);
		createEReference(costEClass, COST__COST_FUNCTION);

		investmentEClass = createEClass(INVESTMENT);

		handlingTimeEClass = createEClass(HANDLING_TIME);

		iCostFunctionEClass = createEClass(ICOST_FUNCTION);

		fixedCostFunctionEClass = createEClass(FIXED_COST_FUNCTION);
		createEAttribute(fixedCostFunctionEClass, FIXED_COST_FUNCTION__VALUE);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private boolean isInitialized = false;

	/**
	 * Complete the initialization of the package and its meta-model.  This
	 * method is guarded to have no affect on any invocation but its first.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void initializePackageContents() {
		if (isInitialized) return;
		isInitialized = true;

		// Initialize package
		setName(eNAME);
		setNsPrefix(eNS_PREFIX);
		setNsURI(eNS_URI);

		// Obtain other dependent packages
		DNIPackage theDNIPackage = (DNIPackage)EPackage.Registry.INSTANCE.getEPackage(DNIPackage.eNS_URI);
		EcorePackage theEcorePackage = (EcorePackage)EPackage.Registry.INSTANCE.getEPackage(EcorePackage.eNS_URI);

		// Create type parameters
		ETypeParameter iAdaptableEntityEClass_T = addETypeParameter(iAdaptableEntityEClass, "T");

		// Set bounds for type parameters
		EGenericType g1 = createEGenericType(theDNIPackage.getITypedEntity());
		iAdaptableEntityEClass_T.getEBounds().add(g1);

		// Add supertypes to classes
		iAdaptableEntityEClass.getESuperTypes().add(this.getICostable());
		g1 = createEGenericType(this.getIAdaptableEntity());
		EGenericType g2 = createEGenericType(theDNIPackage.getNodeType());
		g1.getETypeArguments().add(g2);
		adaptableNodeEClass.getEGenericSuperTypes().add(g1);
		g1 = createEGenericType(this.getIAdaptableGroupableEntity());
		adaptableNodeEClass.getEGenericSuperTypes().add(g1);
		g1 = createEGenericType(this.getIAdaptableEntity());
		g2 = createEGenericType(theDNIPackage.getLinkType());
		g1.getETypeArguments().add(g2);
		adaptableLinkEClass.getEGenericSuperTypes().add(g1);
		g1 = createEGenericType(this.getIAdaptableGroupableEntity());
		adaptableLinkEClass.getEGenericSuperTypes().add(g1);
		g1 = createEGenericType(this.getIAdaptableEntity());
		g2 = createEGenericType(theDNIPackage.getLinkPerformanceType());
		g1.getETypeArguments().add(g2);
		adaptableLinkPerformanceEClass.getEGenericSuperTypes().add(g1);
		g1 = createEGenericType(this.getIAdaptableEntity());
		g2 = createEGenericType(theDNIPackage.getEndPerformanceType());
		g1.getETypeArguments().add(g2);
		adaptableEndPerformanceEClass.getEGenericSuperTypes().add(g1);
		g1 = createEGenericType(this.getIAdaptableEntity());
		g2 = createEGenericType(theDNIPackage.getIntermediatePerformanceType());
		g1.getETypeArguments().add(g2);
		adaptableIntermediatePerformanceEClass.getEGenericSuperTypes().add(g1);
		g1 = createEGenericType(this.getIAdaptableEntity());
		g2 = createEGenericType(theDNIPackage.getSdnNodePerformanceType());
		g1.getETypeArguments().add(g2);
		adaptableSdnNodePerformanceEClass.getEGenericSuperTypes().add(g1);
		g1 = createEGenericType(this.getIAdaptableEntity());
		g2 = createEGenericType(theDNIPackage.getNetworkInterfaceType());
		g1.getETypeArguments().add(g2);
		adaptableNetworkInterfaceEClass.getEGenericSuperTypes().add(g1);
		g1 = createEGenericType(this.getIAdaptableEntity());
		g2 = createEGenericType(theDNIPackage.getNetworkInterfacePerformanceType());
		g1.getETypeArguments().add(g2);
		adaptableNetworkInterfacePerformanceEClass.getEGenericSuperTypes().add(g1);
		iAdaptationGroupEClass.getESuperTypes().add(theDNIPackage.getNamedElement());
		iAdaptationGroupEClass.getESuperTypes().add(theDNIPackage.getIdentifier());
		nodeAdaptationGroupEClass.getESuperTypes().add(this.getIAdaptationGroup());
		linkAdaptationGroupEClass.getESuperTypes().add(this.getIAdaptationGroup());
		alternativeDependencySetEClass.getESuperTypes().add(this.getAlternativeDependency());
		adaptableDependencyEClass.getESuperTypes().add(this.getICostable());
		alternativeVariableSetEClass.getESuperTypes().add(this.getAlternativeVariable());
		adaptableVariableEClass.getESuperTypes().add(this.getICostable());
		investmentEClass.getESuperTypes().add(this.getCost());
		handlingTimeEClass.getESuperTypes().add(this.getCost());
		fixedCostFunctionEClass.getESuperTypes().add(this.getICostFunction());

		// Initialize classes, features, and operations; add parameters
		initEClass(adaptationPointsEClass, AdaptationPoints.class, "AdaptationPoints", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getAdaptationPoints_Repositories(), this.getAdaptationRepository(), null, "repositories", null, 0, 1, AdaptationPoints.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getAdaptationPoints_Groups(), this.getAdaptationGroups(), null, "groups", null, 0, 1, AdaptationPoints.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getAdaptationPoints_NetworkInfrastructure(), theDNIPackage.getNetworkInfrastructure(), null, "networkInfrastructure", null, 0, 1, AdaptationPoints.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(adaptationRepositoryEClass, AdaptationRepository.class, "AdaptationRepository", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getAdaptationRepository_Nodes(), this.getAdaptableNode(), null, "nodes", null, 0, -1, AdaptationRepository.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getAdaptationRepository_EndPerformances(), this.getAdaptableEndPerformance(), null, "endPerformances", null, 0, -1, AdaptationRepository.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getAdaptationRepository_IntermediatePerformances(), this.getAdaptableIntermediatePerformance(), null, "intermediatePerformances", null, 0, -1, AdaptationRepository.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getAdaptationRepository_SdnNodePerformances(), this.getAdaptableSdnNodePerformance(), null, "sdnNodePerformances", null, 0, -1, AdaptationRepository.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getAdaptationRepository_NetworkInterfaces(), this.getAdaptableNetworkInterface(), null, "networkInterfaces", null, 0, -1, AdaptationRepository.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getAdaptationRepository_NetworkInterfacePerformances(), this.getAdaptableNetworkInterfacePerformance(), null, "networkInterfacePerformances", null, 0, -1, AdaptationRepository.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getAdaptationRepository_Links(), this.getAdaptableLink(), null, "links", null, 0, -1, AdaptationRepository.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getAdaptationRepository_LinkPerformances(), this.getAdaptableLinkPerformance(), null, "linkPerformances", null, 0, -1, AdaptationRepository.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(iAdaptableEntityEClass, IAdaptableEntity.class, "IAdaptableEntity", IS_ABSTRACT, IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		g1 = createEGenericType(iAdaptableEntityEClass_T);
		initEReference(getIAdaptableEntity_EntityType(), g1, null, "entityType", null, 0, 1, IAdaptableEntity.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(iAdaptableGroupableEntityEClass, IAdaptableGroupableEntity.class, "IAdaptableGroupableEntity", IS_ABSTRACT, IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(adaptableNodeEClass, AdaptableNode.class, "AdaptableNode", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getAdaptableNode_Name(), theEcorePackage.getEString(), "name", null, 0, 1, AdaptableNode.class, IS_TRANSIENT, IS_VOLATILE, !IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, !IS_UNIQUE, IS_DERIVED, IS_ORDERED);
		initEReference(getAdaptableNode_EndPerformance(), this.getAdaptableEndPerformance(), null, "endPerformance", null, 0, -1, AdaptableNode.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getAdaptableNode_IntermediatePerformance(), this.getAdaptableIntermediatePerformance(), null, "intermediatePerformance", null, 0, -1, AdaptableNode.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getAdaptableNode_SdnNodePerformance(), this.getAdaptableSdnNodePerformance(), null, "sdnNodePerformance", null, 0, -1, AdaptableNode.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getAdaptableNode_NetworkInterface(), this.getAdaptableNetworkInterface(), null, "networkInterface", null, 0, -1, AdaptableNode.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getAdaptableNode_AdaptationGroup(), this.getNodeAdaptationGroup(), this.getNodeAdaptationGroup_Items(), "adaptationGroup", null, 0, 1, AdaptableNode.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(adaptableLinkEClass, AdaptableLink.class, "AdaptableLink", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getAdaptableLink_Name(), theEcorePackage.getEString(), "name", null, 0, 1, AdaptableLink.class, IS_TRANSIENT, IS_VOLATILE, !IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, !IS_UNIQUE, IS_DERIVED, IS_ORDERED);
		initEReference(getAdaptableLink_LinkPerformance(), this.getAdaptableLinkPerformance(), null, "linkPerformance", null, 0, -1, AdaptableLink.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getAdaptableLink_NetworkInterface(), this.getAdaptableNetworkInterface(), null, "networkInterface", null, 0, -1, AdaptableLink.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getAdaptableLink_AdaptationGroup(), this.getLinkAdaptationGroup(), this.getLinkAdaptationGroup_Items(), "adaptationGroup", null, 0, 1, AdaptableLink.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(adaptableLinkPerformanceEClass, AdaptableLinkPerformance.class, "AdaptableLinkPerformance", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getAdaptableLinkPerformance_Name(), theEcorePackage.getEString(), "name", null, 0, 1, AdaptableLinkPerformance.class, IS_TRANSIENT, IS_VOLATILE, !IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, !IS_UNIQUE, IS_DERIVED, IS_ORDERED);
		initEReference(getAdaptableLinkPerformance_PropagationDelay(), this.getAlternativeVariable(), null, "propagationDelay", null, 0, 1, AdaptableLinkPerformance.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getAdaptableLinkPerformance_MaximalSupportedBandwidth(), this.getAlternativeVariable(), null, "maximalSupportedBandwidth", null, 0, 1, AdaptableLinkPerformance.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(adaptableEndPerformanceEClass, AdaptableEndPerformance.class, "AdaptableEndPerformance", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getAdaptableEndPerformance_Name(), theEcorePackage.getEString(), "name", null, 0, 1, AdaptableEndPerformance.class, IS_TRANSIENT, IS_VOLATILE, !IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, !IS_UNIQUE, IS_DERIVED, IS_ORDERED);
		initEReference(getAdaptableEndPerformance_SoftwareLayersDelay(), this.getAlternativeVariable(), null, "softwareLayersDelay", null, 0, 1, AdaptableEndPerformance.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(adaptableIntermediatePerformanceEClass, AdaptableIntermediatePerformance.class, "AdaptableIntermediatePerformance", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getAdaptableIntermediatePerformance_Name(), theEcorePackage.getEString(), "name", null, 0, 1, AdaptableIntermediatePerformance.class, IS_TRANSIENT, IS_VOLATILE, !IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, !IS_UNIQUE, IS_DERIVED, IS_ORDERED);
		initEReference(getAdaptableIntermediatePerformance_ForwardingLatency(), this.getAlternativeDependency(), null, "forwardingLatency", null, 0, 1, AdaptableIntermediatePerformance.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getAdaptableIntermediatePerformance_ForwardingBandwidthBPS(), this.getAlternativeDependency(), null, "forwardingBandwidthBPS", null, 0, 1, AdaptableIntermediatePerformance.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getAdaptableIntermediatePerformance_SwitchingCapacityPPS(), this.getAlternativeDependency(), null, "switchingCapacityPPS", null, 0, 1, AdaptableIntermediatePerformance.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(adaptableSdnNodePerformanceEClass, AdaptableSdnNodePerformance.class, "AdaptableSdnNodePerformance", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getAdaptableSdnNodePerformance_Name(), theEcorePackage.getEString(), "name", null, 0, 1, AdaptableSdnNodePerformance.class, IS_TRANSIENT, IS_VOLATILE, !IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, !IS_UNIQUE, IS_DERIVED, IS_ORDERED);
		initEReference(getAdaptableSdnNodePerformance_SoftwareSwitchingPerformance(), this.getAdaptableIntermediatePerformance(), null, "softwareSwitchingPerformance", null, 0, -1, AdaptableSdnNodePerformance.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getAdaptableSdnNodePerformance_HardwareSwitchingPerformance(), this.getAdaptableIntermediatePerformance(), null, "hardwareSwitchingPerformance", null, 0, -1, AdaptableSdnNodePerformance.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(adaptableNetworkInterfaceEClass, AdaptableNetworkInterface.class, "AdaptableNetworkInterface", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getAdaptableNetworkInterface_Name(), theEcorePackage.getEString(), "name", null, 0, 1, AdaptableNetworkInterface.class, IS_TRANSIENT, IS_VOLATILE, !IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, !IS_UNIQUE, IS_DERIVED, IS_ORDERED);
		initEReference(getAdaptableNetworkInterface_NetworkInterfacePerformance(), this.getAdaptableNetworkInterfacePerformance(), null, "networkInterfacePerformance", null, 0, -1, AdaptableNetworkInterface.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(adaptableNetworkInterfacePerformanceEClass, AdaptableNetworkInterfacePerformance.class, "AdaptableNetworkInterfacePerformance", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getAdaptableNetworkInterfacePerformance_Name(), theEcorePackage.getEString(), "name", null, 0, 1, AdaptableNetworkInterfacePerformance.class, IS_TRANSIENT, IS_VOLATILE, !IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, !IS_UNIQUE, IS_DERIVED, IS_ORDERED);
		initEReference(getAdaptableNetworkInterfacePerformance_PacketProcessingTime(), this.getAlternativeVariable(), null, "packetProcessingTime", null, 0, 1, AdaptableNetworkInterfacePerformance.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getAdaptableNetworkInterfacePerformance_InterfaceThroughput(), this.getAlternativeVariable(), null, "interfaceThroughput", null, 0, 1, AdaptableNetworkInterfacePerformance.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(adaptationGroupsEClass, AdaptationGroups.class, "AdaptationGroups", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getAdaptationGroups_Nodes(), this.getNodeAdaptationGroup(), null, "nodes", null, 0, -1, AdaptationGroups.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getAdaptationGroups_Links(), this.getLinkAdaptationGroup(), null, "links", null, 0, -1, AdaptationGroups.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(iAdaptationGroupEClass, IAdaptationGroup.class, "IAdaptationGroup", IS_ABSTRACT, IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(nodeAdaptationGroupEClass, NodeAdaptationGroup.class, "NodeAdaptationGroup", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getNodeAdaptationGroup_Items(), this.getAdaptableNode(), this.getAdaptableNode_AdaptationGroup(), "items", null, 0, -1, NodeAdaptationGroup.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(linkAdaptationGroupEClass, LinkAdaptationGroup.class, "LinkAdaptationGroup", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getLinkAdaptationGroup_Items(), this.getAdaptableLink(), this.getAdaptableLink_AdaptationGroup(), "items", null, 0, -1, LinkAdaptationGroup.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(alternativeDependencyEClass, AlternativeDependency.class, "AlternativeDependency", IS_ABSTRACT, IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(alternativeDependencySetEClass, AlternativeDependencySet.class, "AlternativeDependencySet", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getAlternativeDependencySet_Alternative(), this.getAdaptableDependency(), null, "alternative", null, 0, -1, AlternativeDependencySet.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(adaptableDependencyEClass, AdaptableDependency.class, "AdaptableDependency", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getAdaptableDependency_Parameter(), theDNIPackage.getDependency(), null, "parameter", null, 1, 1, AdaptableDependency.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(alternativeVariableEClass, AlternativeVariable.class, "AlternativeVariable", IS_ABSTRACT, IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(alternativeVariableSetEClass, AlternativeVariableSet.class, "AlternativeVariableSet", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getAlternativeVariableSet_Alternative(), this.getAdaptableVariable(), null, "alternative", null, 0, -1, AlternativeVariableSet.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(adaptableVariableEClass, AdaptableVariable.class, "AdaptableVariable", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getAdaptableVariable_Parameter(), theDNIPackage.getVariable(), null, "parameter", null, 1, 1, AdaptableVariable.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(iCostableEClass, ICostable.class, "ICostable", IS_ABSTRACT, IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getICostable_Cost(), this.getCost(), null, "cost", null, 0, -1, ICostable.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(costEClass, Cost.class, "Cost", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getCost_CostFunction(), this.getICostFunction(), null, "costFunction", null, 1, 1, Cost.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(investmentEClass, Investment.class, "Investment", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(handlingTimeEClass, HandlingTime.class, "HandlingTime", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(iCostFunctionEClass, ICostFunction.class, "ICostFunction", IS_ABSTRACT, IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(fixedCostFunctionEClass, FixedCostFunction.class, "FixedCostFunction", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getFixedCostFunction_Value(), theEcorePackage.getEDouble(), "value", null, 0, 1, FixedCostFunction.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, !IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		// Create resource
		createResource(eNS_URI);
	}

} //DNIAPPackageImpl
